/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

var UnMHTConfirm = {
    result : null,
    base : "",
    dialog : null,
    existsMessage1 : "",
    existsMessage2 : "",
    useFile : false,
  
    init : function () {
        var arg = window.arguments [0];
    
        UnMHTConfirm.useFile = true;
        if (arg [9] == null) {
            UnMHTConfirm.useFile = false;
        }
        
        UnMHTConfirm.result = arg [0];
        UnMHTConfirm.base = arg [10];
        UnMHTConfirm.existsMessage1 = arg [11];
        UnMHTConfirm.existsMessage2 = arg [12];
    
        var button;
    
        UnMHTConfirm.dialog = document.getElementById ("unmht_confirm");
        UnMHTConfirm.dialog.setAttribute ("title", arg [1]);
    
        button = UnMHTConfirm.dialog.getButton ("accept");
        button.setAttribute ("label", arg [4]);
        button = UnMHTConfirm.dialog.getButton ("cancel");
        button.setAttribute ("label", arg [5]);
    
        button = UnMHTConfirm.dialog.getButton ("extra1");
        if (arg [6] == null) {
            button.hidden = true;
        }
        else {
            button.setAttribute ("label", arg [6]);
            button.addEventListener
            ("command",
             function () {
                UnMHTConfirm.onClick ( "abort");
            }, true);
        }
    
        document.getElementById ("message1").value = arg [2];
        document.getElementById ("message2").value = arg [3];
        if (arg [13] == null) {
            document.getElementById ("message2").hidden = true;
        }
        else {
            document.getElementById ("message3").value = arg [13];
        }

        document.getElementById ("apply_to_all").checked = false;
        document.getElementById ("apply_to_all").label = arg [8];
    
        if (arg [7] == null) {
            document.getElementById ("renamebox").hidden = true;
        }
        else {
            document.getElementById ("rename").checked = false;
            document.getElementById ("rename").label = arg [7];
            document.getElementById ("filename").disabled = true;
            document.getElementById ("filename").value = arg [9];
        }
    },
  
    onCheckApplyToAll : function () {
        if (UnMHTConfirm.useFile) {
            document.getElementById ("rename").checked = false;
            document.getElementById ("filename").disabled = true;
    
            UnMHTConfirm.dialog.getButton ("cancel").disabled = false;
        }
    },
  
    onCheckRename : function () {
        if (document.getElementById ("rename").checked) {
            document.getElementById ("apply_to_all").checked = false;
            document.getElementById ("filename").disabled = false;
      
            UnMHTConfirm.dialog.getButton ("cancel").disabled = true;
        }
        else {
            document.getElementById ("filename").disabled = true;
            UnMHTConfirm.dialog.getButton ("cancel").disabled = false;
        }
    },
    
    onClick : function (type) {
        document.getElementById ("rename_exists").value = "";
        document.getElementById ("rename_exists").hidden = true;
        if (document.getElementById ("rename").checked) {
            var file
                = Components.classes ["@mozilla.org/file/local;1"]
                .createInstance (Components.interfaces.nsILocalFile);
            try {
                file.initWithPath (UnMHTConfirm.base);
            }
            catch (e) {
                return false;
            }
            var filename = document.getElementById ("filename").value;
            file.appendRelativePath (filename);
        
            if (file.exists ()) {
                document.getElementById ("rename_exists").value
                    = UnMHTConfirm.existsMessage1
                    + " " + filename + " " + UnMHTConfirm.existsMessage2;
                document.getElementById ("rename_exists").hidden = false;
                document.getElementById ("filename").focus ();
          
                return false;
            }
        }
    
        UnMHTConfirm.result.result = type;
        UnMHTConfirm.result.applyToAll
        = document.getElementById ("apply_to_all").checked;
        UnMHTConfirm.result.rename
        = document.getElementById ("rename").checked;
        UnMHTConfirm.result.filename
        = document.getElementById ("filename").value;
        if (type == "abort") {
            UnMHTConfirm.dialog.close ();
        }
    
        return true;
    }
};
