/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/**
 * 󥹥ȡ뤹ĥ
 */
var Extension = {
    /* String  С */
    version        : "5.1.0.1",
    /* String  ɽ̾ */
    displayName    : "UnMHT",
    /* String  ĥμ̾ */
    appName        : "unmht",
    /* String  ĥκ */
    author         : "arai",
    /* Array  󥹥ȡ뤹 components Υꥹ
     *   [String ե̾, ...] */
    componentsList : [
        "arUnMHTContentHandler.js",
        "arUnMHTContentPolicy.js",
        "arUnMHTMhtmlProtocolHandler.js",
        "arUnMHTProtocolHandler.js",
        "arIUnMHTProtocolHandler.xpt"
        ],
    /* Array  󥤥󥹥ȡ뤷ΤΤ components Υꥹ
     *   [String ե̾, ...] */
    uninstallList  : [
        ],
    /* Array  󥹥ȡ뤹 locale Υꥹ
     *   [String ̾, ...] */
    localesList    : [
        "cs-CZ",
        "de-DE",
        "en-GB",
        "es-ES",
        "fr-FR",
        "hu-HU",
        "it-IT",
        "ja-JP",
        "pl-PL",
        "pt-BR",
        "ru-RU",
        "uk-UA",
        "vi-VN",
        "zh-CN",
        "zh-TW",
        
        "en-US"
        ]
};

/**
 * 󥹥ȡоݤξ
 *
 * @param  Object Extension
 *         󥹥ȡ뤹ĥ
 * @param  Boolean global
 *         Global ʤ true
 *         Profile ʤ false
 */
function arSettings (Extension, global) {
    if (global) {
        this.chrome = getFolder ("chrome");
        this.flag   = DELAYED_CHROME;
    }
    else {
        this.chrome = getFolder ("Profile", "chrome");
        this.flag   = PROFILE_CHROME;
    }
    this.components = getFolder ("components");
    this.jarPath    = getFolder (this.chrome, Extension.appName + ".jar");
    this.exists     = File.exists (this.jarPath);
}
arSettings.prototype = {
    chrome : "",     /* String  chrome Υѥ */
    components : "", /* String  components Υѥ */
    flag : 0,        /* Number  󥹥ȡΥե饰 */
    jarPath : "",    /* String  jar Υѥ */
    exists : false   /* Boolean  jar ¸ߤ뤫ɤ */
};

/**
 * 󥹥ȡ
 *
 * @param  Object Extension
 *         󥹥ȡ뤹ĥ
 */
function arInstaller (Extension) {
    this.init (Extension);
}

arInstaller.prototype = {
    extension : null, /* Object  󥹥ȡ뤹ĥ */
    global : null,    /* arSettings  Global 󥹥ȡ */
    profile : null,   /* arSettings  Profile 󥹥ȡ */
    
    /**
     * 
     *
     * @param  Object Extension
     *         󥹥ȡ뤹ĥ
     */
    init : function (Extension) {
        this.extension = Extension;
        this.global = new arSettings (Extension, true);
        this.profile = new arSettings (Extension, false);
    },
    
    /**
     * פʥե
     */
    uninstall : function () {
        var i;
        var err;
        var oldFile;
        
        if (buildID <= 2003072300) {
            /* Wazilla ǤƤΥեƤǤʤȥ󥹥ȡǤʤ
             * ޤöưƤǤʤȺǤʤ */
            
            /* ư */
            initInstall ("uninstall_old",
                         "/" + this.extension.author + "/uninstall_old",
                         "0.0");
            if (this.global.exists) {
                File.rename (this.global.jarPath,
                             this.extension.appName
                             + "_uninstalled");
            }
            if (this.profile.exists) {
                File.rename (this.profile.jarPath,
                             this.extension.appName
                             + "_uninstalled");
            }
            for (i = 0; i < this.extension.uninstallList.length; i ++) {
                oldFile = getFolder (this.global.components,
                                     this.extension.uninstallList [i]);
                if (File.exists (oldFile)) {
                    File.rename (oldFile,
                                 this.extension.appName
                                 + "_uninstalled2_" + i);
                }
                oldFile = getFolder (this.profile.chrome,
                                     this.extension.uninstallList [i]);
                if (File.exists (oldFile)) {
                    File.rename (oldFile,
                                 this.extension.appName
                                 + "_uninstalled2_" + i);
                }
            }
            for (i = 0; i < this.extension.componentsList.length; i ++) {
                oldFile = getFolder (this.global.components,
                                     this.extension.componentsList [i]);
                if (File.exists (oldFile)) {
                    File.rename (oldFile,
                                 this.extension.appName
                                 + "_uninstalled_" + i);
                }
                oldFile = getFolder (this.profile.chrome,
                                     this.extension.componentsList [i]);
                if (File.exists (oldFile)) {
                    File.rename (oldFile,
                                 this.extension.appName
                                 + "_uninstalled_" + i);
                }
            }
            err = getLastError ();
            if (err == SUCCESS) {
                var err = performInstall ();
                if (err == SUCCESS) {
                    cancelInstall (err);
                }
            }
            else {
                cancelInstall (err);
            }
    
            /*  */
            initInstall ("uninstall_old",
                         "/" + this.extension.author + "/uninstall_old",
                         "0.1");
            if (this.global.exists) {
                File.remove (getFolder (this.global.chrome,
                                        this.extension.appName
                                        + "_uninstalled"));
            }
            if (this.profile.exists) {
                File.remove (getFolder (this.profile.chrome,
                                        this.extension.appName
                                        + "_uninstalled"));
            }
            for (i = 0; i < this.extension.uninstallList.length; i ++) {
                oldFile = getFolder (this.global.components,
                                     this.extension.appName
                                     + "_uninstalled2_" + i);
                if (File.exists (oldFile)) {
                    File.remove (oldFile);
                }
                oldFile = getFolder (this.profile.chrome,
                                     this.extension.appName
                                     + "_uninstalled2_" + i);
                if (File.exists (oldFile)) {
                    File.remove (oldFile);
                }
            }
            for (i = 0; i < this.extension.componentsList.length; i ++) {
                oldFile = getFolder (this.global.components,
                                     this.extension.appName
                                     + "_uninstalled_" + i);
                if (File.exists (oldFile)) {
                    File.remove (oldFile);
                }
                oldFile = getFolder (this.profile.chrome,
                                     this.extension.appName
                                     + "_uninstalled_" + i);
                if (File.exists (oldFile)) {
                    File.remove (oldFile);
                }
            }
            err = getLastError ();
            if (err == SUCCESS) {
                var err = performInstall ();
                if (err == SUCCESS) {
                    cancelInstall (err);
                }
            }
            else {
                cancelInstall (err);
            }
        }
        else {
            /* Wazilla ʳǤפˤʤäեΤߺ */
            
            initInstall ("uninstall_old",
                         "/" + this.extension.author + "/uninstall_old",
                         "0.0");
            for (i = 0; i < this.extension.uninstallList.length; i ++) {
                oldFile = getFolder (this.global.components,
                                     this.extension.uninstallList [i]);
                if (File.exists (oldFile)) {
                    File.remove (oldFile);
                }
                oldFile = getFolder (this.profile.chrome,
                                     this.extension.uninstallList [i]);
                if (File.exists (oldFile)) {
                    File.remove (oldFile);
                }
            }
            err = getLastError ();
            if (err == SUCCESS) {
                var err = performInstall ();
                if (err == SUCCESS) {
                    cancelInstall (err);
                }
            }
            else {
                cancelInstall (err);
            }
        }
    },
    
    /**
     * 󥹥ȡ
     */
    getTarget : function () {
        this.target = this.global;
    },
    
    /**
     * 󥹥ȡ뤹
     */
    install : function () {
        initInstall (this.extension.displayName
                     + " " + this.extension.version,
                     "/" + this.extension.author
                     + "/" + this.extension.appName,
                     this.extension.version);
        
        /* components Υ󥹥ȡ */
        for (i = 0; i < this.extension.componentsList.length; i ++) {
            addFile (null,
                     "components/" + this.extension.componentsList [i],
                     this.global.components, null);
        }
        
        /* jar Υ󥹥ȡ */
        addFile ("/" + this.extension.author
                 + "/" + this.extension.appName,
                 this.extension.version,
                 "chrome/" + this.extension.appName + ".jar",
                 this.target.chrome,
                 null);
        registerChrome (CONTENT | this.target.flag,
                        this.target.jarPath,
                        "content/");
        
        /* locale Υ󥹥ȡ */
        for (i = 0; i < this.extension.localesList.length; i ++) {
            var locale = this.extension.localesList [i];
            registerChrome (LOCALE | this.target.flag,
                            this.target.jarPath,
                            "locale/" + locale +"/");
        }

        var err;
        err = getLastError ();
        if (err == SUCCESS) {
            err = performInstall ();
            if (err == SUCCESS || err == 999) {
            }
            else {
                cancelInstall (err);
            }
        }
        else {
            cancelInstall (err);
        }
    }
};

var installer = new arInstaller (Extension);
installer.uninstall ();
installer.getTarget ();
installer.install ();
